Crashpad

Public Member Functions | Protected Member Functions | List of all members
crashpad::MinidumpUnloadedModuleWriter Class Referencefinal

The writer for a MINIDUMP_UNLOADED_MODULE object in a minidump file. More...

`#include "minidump/minidump_unloaded_module_writer.h"`

Inheritance diagram for crashpad::MinidumpUnloadedModuleWriter:

## Public Member Functions
void | InitializeFromSnapshot (const UnloadedModuleSnapshot &unloaded_module_snapshot)
| Initializes the MINIDUMP_UNLOADED_MODULE based on unloaded_module_snapshot. More...
const MINIDUMP_UNLOADED_MODULE * | MinidumpUnloadedModule () const
| Returns a MINIDUMP_UNLOADED_MODULE referencing this object’s data. More...
void | SetName (const std::string &name)
| Arranges for MINIDUMP_UNLOADED_MODULE::ModuleNameRva to point to a MINIDUMP_STRING containing name. More...
void | SetImageBaseAddress (uint64_t image_base_address)
| Sets MINIDUMP_UNLOADED_MODULE::BaseOfImage.
void | SetImageSize (uint32_t image_size)
| Sets MINIDUMP_UNLOADED_MODULE::SizeOfImage.
void | SetChecksum (uint32_t checksum)
| Sets MINIDUMP_UNLOADED_MODULE::CheckSum.
void | SetTimestamp (time_t timestamp)
| Sets MINIDUMP_UNLOADED_MODULE::TimeDateStamp. More...
Public Member Functions inherited from crashpad::internal::MinidumpWritable
virtual bool | WriteEverything (FileWriterInterface *file_writer)
| Writes an object and all of its children to a minidump file. More...
void | RegisterRVA (RVA *rva)
| Registers a file offset pointer as one that should point to the object on which this method is called. More...
void | RegisterLocationDescriptor (MINIDUMP_LOCATION_DESCRIPTOR *location_descriptor)
| Registers a location descriptor as one that should point to the object on which this method is called. More...

## Protected Member Functions
bool | Freeze () override
| Transitions the object from kStateMutable to kStateFrozen. More...
size_t | SizeOfObject () override
| Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment. More...
std::vector< MinidumpWritable * > | Children () override
| Returns the object’s children. More...
bool | WriteObject (FileWriterInterface *file_writer) override
| Writes the object’s content. More...
Protected Member Functions inherited from crashpad::internal::MinidumpWritable
State | state () const
| The state of the object.
virtual size_t | Alignment ()
| Returns the object’s desired byte-boundary alignment. More...
virtual Phase | WritePhase ()
| Returns the object’s desired write phase. More...
size_t | WillWriteAtOffset (Phase phase, FileOffset *offset, std::vector< MinidumpWritable *> *write_sequence)
| Prepares the object to be written at a known file offset, transitioning it from kStateFrozen to kStateWritable. More...
virtual bool | WillWriteAtOffsetImpl (FileOffset offset)
| Called once an object’s writable file offset is determined, as it transitions into kStateWritable. More...
bool | WritePaddingAndObject (FileWriterInterface *file_writer)
| Writes the object, transitioning it from kStateWritable to kStateWritten. More...

## Additional Inherited Members
Protected Types inherited from crashpad::internal::MinidumpWritable
enum | State
| Identifies the state of an object. More...
enum | Phase
| Identifies the phase during which an object will be written to a minidump file. More...
Static Protected Attributes inherited from crashpad::internal::MinidumpWritable
static const size_t | kInvalidSize
| A size value used to signal failure by methods that return `size_t`. More...

## Detailed Description

The writer for a MINIDUMP_UNLOADED_MODULE object in a minidump file.

Because MINIDUMP_UNLOADED_MODULE objects only appear as elements of MINIDUMP_UNLOADED_MODULE_LIST objects, this class does not write any data on its own. It makes its MINIDUMP_UNLOADED_MODULE data available to its MinidumpUnloadedModuleListWriter parent, which writes it as part of a MINIDUMP_UNLOADED_MODULE_LIST.

## Member Function Documentation

## ◆ Children()

std::vector< internal::MinidumpWritable * > crashpad::MinidumpUnloadedModuleWriter::Children | ( |  | ) |
| override protected virtual

Returns the object’s children.

Note
  Valid in kStateFrozen or any subsequent state.

Reimplemented from crashpad::internal::MinidumpWritable.

## ◆ Freeze()

bool crashpad::MinidumpUnloadedModuleWriter::Freeze | ( |  | ) |
| override protected virtual

Transitions the object from kStateMutable to kStateFrozen.

The default implementation marks the object as frozen and recursively calls Freeze() on all of its children. Subclasses may override this method to perform processing that should only be done once callers have finished populating an object with data. Typically, a subclass implementation would call RegisterRVA() or RegisterLocationDescriptor() on other objects as appropriate, because at the time Freeze() runs, the in-memory locations of RVAs and location descriptors are known and will not change for the remaining duration of an object’s lifetime.

Returns
  `true` on success. `false` on failure, with an appropriate message logged.

Reimplemented from crashpad::internal::MinidumpWritable.

## ◆ InitializeFromSnapshot()

void crashpad::MinidumpUnloadedModuleWriter::InitializeFromSnapshot | ( | const UnloadedModuleSnapshot & | unloaded_module_snapshot | ) |

Initializes the MINIDUMP_UNLOADED_MODULE based on unloaded_module_snapshot.

Parameters

  [in] | unloaded_module_snapshot | The unloaded module snapshot to use as source data.

Note
  Valid in kStateMutable. No mutator methods may be called before this method, and it is not normally necessary to call any mutator methods after this method.

## ◆ MinidumpUnloadedModule()

const MINIDUMP_UNLOADED_MODULE * crashpad::MinidumpUnloadedModuleWriter::MinidumpUnloadedModule | ( |  | ) | const

Returns a MINIDUMP_UNLOADED_MODULE referencing this object’s data.

This method is expected to be called by a MinidumpUnloadedModuleListWriter in order to obtain a MINIDUMP_UNLOADED_MODULE to include in its list.

Note
  Valid in kStateWritable.

## ◆ SetName()

void crashpad::MinidumpUnloadedModuleWriter::SetName | ( | const std::string & | name | ) |

Arranges for MINIDUMP_UNLOADED_MODULE::ModuleNameRva to point to a MINIDUMP_STRING containing name.

Note
  Valid in kStateMutable.

## ◆ SetTimestamp()

void crashpad::MinidumpUnloadedModuleWriter::SetTimestamp | ( | time_t | timestamp | ) |

Sets MINIDUMP_UNLOADED_MODULE::TimeDateStamp.

Note
  Valid in kStateMutable.

## ◆ SizeOfObject()

size_t crashpad::MinidumpUnloadedModuleWriter::SizeOfObject | ( |  | ) |
| override protected virtual

Returns the amount of space that this object will consume when written to a minidump file, in bytes, not including any leading or trailing padding necessary to maintain proper alignment.

Note
  Valid in kStateFrozen or any subsequent state.

Implements crashpad::internal::MinidumpWritable.

## ◆ WriteObject()

bool crashpad::MinidumpUnloadedModuleWriter::WriteObject | ( | FileWriterInterface * | file_writer | ) |
| override protected virtual

Writes the object’s content.

Parameters

  [in] | file_writer | The file writer to receive the object’s content.

Returns
  `true` on success. `false` on error, indicating that the content could not be written to the minidump file.

Note
  Valid in kStateWritable. The object will transition to kStateWritten after this method returns.

Implements crashpad::internal::MinidumpWritable.

The documentation for this class was generated from the following files:

- minidump/minidump_unloaded_module_writer.h
- minidump/minidump_unloaded_module_writer.cc